﻿'DXF Halftone 2.1 by Tomi Syväjärvi 2011
'This software is released under GNU General Public License v3.0
'Written in Blitzmax, also requires MaxGUI (available for free for Blitzmax owners)

SuperStrict


Const VERSION:String = "2.1"

'Windows and main GUI groups setup

Global MainWindow:TGadget = CreateWindow("DXF Halftone " + VERSION, 400, 690, 525, 340, Null, WINDOW_CLIENTCOORDS | WINDOW_TITLEBAR | WINDOW_STATUS)
Global PrWindow:TGadget = CreateWindow("Preview", 400, 50, 520, 580, Null, WINDOW_CLIENTCOORDS | WINDOW_TITLEBAR | WINDOW_STATUS | WINDOW_RESIZABLE)
Global LegalWindow:TGadget = CreateWindow("Legal notice ", 400, 750, 525, 200, Null, WINDOW_CLIENTCOORDS | WINDOW_TITLEBAR | WINDOW_HIDDEN)
Global MainCanvas:TGadget = CreateCanvas(10, 10, 500, 500, PrWindow)

Local MainTabber:TGadget = CreateTabber(0, 5, 540, 340, Mainwindow)
AddGadgetItem(MainTabber, "General", GADGETITEM_DEFAULT)
AddGadgetItem(MainTabber, "Dot Halftone")
AddGadgetItem(MainTabber, "Path width modulation")
AddGadgetItem(MainTabber, "DXF export")
AddGadgetItem(MainTabber, "GCode export")

Local MainGui:TGadget = CreatePanel(10, 10, 500, 250, MainTabber, PANEL_GROUP, "")
Local DotGui:TGadget = CreatePanel(10, 10, 500, 280, MainTabber, PANEL_GROUP, "")
Local PathGui:TGadget = CreatePanel(10, 10, 500, 280, MainTabber, PANEL_GROUP, "")
Local ExportGui:TGadget = CreatePanel(10, 10, 500, 285, MainTabber, PANEL_GROUP, "")
Local GCodeGui:TGadget = CreatePanel(10, 10, 500, 285, MainTabber, PANEL_GROUP, "")


'Legal notice window
Local Notice:String = "Copyright (C) 2011 Tomi Syväjärvi ~n" ..
    + "This program is free software: you can redistribute it and/or modify" ..
    + " it under the terms of the GNU General Public License as published by" ..
    + " the Free Software Foundation, either version 3 of the License, or" ..
    + " (at your option) any later version." ..
    + " This program is distributed in the hope that it will be useful," ..
    + " but WITHOUT ANY WARRANTY; without even the implied warranty of" ..
    + " MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the" ..
    + " GNU General Public License for more details." ..
    + " You should have received a copy of the GNU General Public License" ..
    + " along with this program.  If not, see http://www.gnu.org/licenses ~n ~n" ..
	+ "You should always inspect the generated GCode carefully before running it on any machine. ~n" ..
	+ "Have fun! :)"
	
		
Local Legalnotice:TGadget = CreateLabel(Notice, 5, 5, 515, 150, LegalWindow, LABEL_FRAME | LABEL_LEFT)

Global noticeButton:TGadget = CreateButton("Don't show this notice in the future", 5, 170, 200, 24, Legalwindow, BUTTON_CHECKBOX)
Global CloseButton:TGadget = CreateButton("Understood.", 420, 170, 100, 25, LegalWindow)
SetButtonState(noticeButton, True)

'General settings GUI

'Local ImgFileTxt:TGadget = CreateLabel("Source image:", 5, 5, 150, 15, MainGui, LABEL_LEFT)
Local ImgFileGroup:TGadget = CreatePanel(5, 5, 285, 60, MainGui, PANEL_GROUP, "Source image:")

Global LoadImageBox:TGadget = CreateTextField(5, 5, 230, 25, ImgFileGroup)
SetGadgetText(LoadImageBox, "filename.jpeg")
Local SelectImageBtn:TGadget = CreateButton("...", 240, 5, 25, 24, ImgFileGroup)

Local ColorG:TGadget = CreatePanel(300, 5, 185, 60, MainGui, PANEL_GROUP, "Color switch:")

Global ColorRadio1:TGadget = CreateButton("Black/White", 0, 7, 100, 24, ColorG, BUTTON_RADIO)
Global ColorRadio2:TGadget = CreateButton("White/Black", 90, 7, 100, 24, ColorG, BUTTON_RADIO)
SetButtonState(ColorRadio1, 1)

Local SettingsG:TGadget = CreatePanel(5, 70, 480, 60, MainGui, PANEL_GROUP, "Settings file:")
Global SettingsBox:TGadget = CreateTextField(5, 5, 230, 25, SettingsG)
SetGadgetText(SettingsBox, "HTSettings.txt")
Local SelectSettingsBtn:TGadget = CreateButton("...", 240, 5, 25, 24, SettingsG)
Local LoadSettingsBtn:TGadget = CreateButton("Load", 275, 5, 35, 24, SettingsG)
Local SaveSettingsBtn:TGadget = CreateButton("Save", 315, 5, 35, 24, SettingsG)
Global AutoSaveBox:TGadget = CreateButton("Save on export", 360, 5, 100, 24, SettingsG, BUTTON_CHECKBOX)


Local WorkGroup:TGadget = CreatePanel(5, 140, 280, 80, MainGui, PANEL_GROUP, "Workpiece dimensions:")

Local WidthtTxt:TGadget = CreateLabel("Width (mm)", 5, 5, 70, 15, WorkGroup, LABEL_CENTER)
Local HeightTxt:TGadget = CreateLabel("Height (mm)", 95, 5, 70, 15, WorkGroup, LABEL_CENTER)

Global WidthBox:TGadget = CreateTextField(5, 25, 70, 25, WorkGroup)
SetGadgetText(WidthBox,"300")
Global HeightBox:TGadget = CreateTextField(95, 25, 70, 25, WorkGroup)

Local BorderTxt:TGadget = CreateLabel("Edge border", 185, 5, 70, 15, WorkGroup, LABEL_CENTER)
Global Borderbox:TGadget = CreateTextField(185, 25, 70, 25, WorkGroup)
SetGadgetText(Borderbox, "0")


Local ActiveGroup:TGadget = CreatePanel(300, 140, 185, 60, MainGui, PANEL_GROUP, "Active filler:")
Global ActiveRadio1:TGadget = CreateButton("Dot halftone", 10, 7, 80, 24, ActiveGroup, BUTTON_RADIO)
Global ActiveRadio2:TGadget = CreateButton("Path width", 95, 7, 80, 24, ActiveGroup, BUTTON_RADIO)
SetButtonState(ActiveRadio1, 1)


'Dot Halftone GUI
Local DotGridGroup:TGadget = CreatePanel(5, 5, 200, 240, DotGui, PANEL_GROUP, "Dot grid:")

Local SpacingTxt:TGadget = CreateLabel("Spacing", 5, 5, 70, 15, DotGridGroup, LABEL_CENTER)
Local RotationTxt:TGadget = CreateLabel("Rotation", 95, 5, 70, 15, DotGridGroup, LABEL_CENTER)

Global SpacingBox:TGadget = CreateTextField(5, 25, 70, 25, DotGridGroup)
SetGadgetText(SpacingBox, "5")
Global RotationBox:TGadget = CreateTextField(95, 25, 70, 25, DotGridGroup)
SetGadgetText(RotationBox, "45")

Local MinDiaTxt:TGadget = CreateLabel("Min. diameter", 5, 60, 70, 15, DotGridGroup, LABEL_CENTER)
Local MaxDiaTxt:TGadget = CreateLabel("Max. diameter", 95, 60, 70, 15, DotGridGroup, LABEL_CENTER)

Global MinDiaBox:TGadget = CreateTextField(5, 80, 70, 25, DotGridGroup)
SetGadgetText(MinDiaBox, "0.5")

Global MaxDiaBox:TGadget = CreateTextField(95, 80, 70, 25, DotGridGroup)
SetGadgetText(MaxDiaBox, "4.5")

Local XOffTxt:TGadget = CreateLabel("X-offset", 5, 110, 70, 15, DotGridGroup, LABEL_CENTER)
Local YOffTxt:TGadget = CreateLabel("Y-offset", 95, 110, 70, 15, DotGridGroup, LABEL_CENTER)

Global XOffBox:TGadget = CreateTextField(5, 130, 70, 25, DotGridGroup)
SetGadgetText(XOffBox, "0")

Global YOffBox:TGadget = CreateTextField(95, 130, 70, 25, DotGridGroup)
SetGadgetText(YOffBox, "0")

Local FitDiaBtn:TGadget = CreateButton("Fit max. D", 95, 180, 70, 25, DotGridGroup)

Local TypeG:TGadget = CreatePanel(215, 5, 270, 45, DotGui, PANEL_GROUP, "Filler type:")

Global TypeRadio1:TGadget = CreateButton("Circle" , 0 , 0 , 50 , 24 , TypeG , BUTTON_RADIO) 
Global TypeRadio2:TGadget = CreateButton("Square" , 50 , 0 , 60 , 24 , TypeG , BUTTON_RADIO) 
Global TypeRadio3:TGadget = CreateButton("45 deg. rotated square", 110, 0, 150, 24, TypeG, BUTTON_RADIO)

SetButtonState(TypeRadio1,1)


'Path width modulation GUI
Local PathParamGroup:TGadget = CreatePanel(5, 5, 200, 240, PathGui, PANEL_GROUP, "Path parameters:")

Local PathSpacingTxt:TGadget = CreateLabel("Spacing", 5, 5, 70, 15, PathParamGroup, LABEL_CENTER)
Local PathRotationTxt:TGadget = CreateLabel("Rotation", 95, 5, 70, 15, PathParamGroup, LABEL_CENTER)

Global PathSpacingBox:TGadget = CreateTextField(5, 25, 70, 25, PathParamGroup)
SetGadgetText(PathSpacingBox, "5")
Global PathRotationBox:TGadget = CreateTextField(95, 25, 70, 25, PathParamGroup)
SetGadgetText(PathRotationBox, "30")

Local PathMinDiaTxt:TGadget = CreateLabel("Min. width", 5, 60, 70, 15, PathParamGroup, LABEL_CENTER)
Local PathMaxDiaTxt:TGadget = CreateLabel("Max. width", 95, 60, 70, 15, PathParamGroup, LABEL_CENTER)

Global PathMinDiaBox:TGadget = CreateTextField(5, 80, 70, 25, PathParamGroup)
SetGadgetText(PathMinDiaBox, "0.5")

Global PathMaxDiaBox:TGadget = CreateTextField(95, 80, 70, 25, PathParamGroup)
SetGadgetText(PathMaxDiaBox, "4.5")

Local PathWlTxt:TGadget = CreateLabel("Wavelength", 5, 110, 70, 15, PathParamGroup, LABEL_CENTER)
Local PathAmplitudeTxt:TGadget = CreateLabel("Amplitude", 95, 110, 70, 15, PathParamGroup, LABEL_CENTER)

Global PathwavelengthBox:TGadget = CreateTextField(5, 130, 70, 25, PathParamGroup)
SetGadgetText(PathwavelengthBox, "20")

Global PathAmplitudeBox:TGadget = CreateTextField(95, 130, 70, 25, PathParamGroup)
SetGadgetText(PathAmplitudeBox, "3")

Local PathXOffTxt:TGadget = CreateLabel("X-offset", 5, 160, 70, 15, PathParamGroup, LABEL_CENTER)
Local PathYOffTxt:TGadget = CreateLabel("Y-offset", 95, 160, 70, 15, PathParamGroup, LABEL_CENTER)

Global PathXOffBox:TGadget = CreateTextField(5, 180, 70, 25, PathParamGroup)
SetGadgetText(PathXOffBox, "0")

Global PathYOffBox:TGadget = CreateTextField(95, 180, 70, 25, PathParamGroup)
SetGadgetText(PathYOffBox, "0")


Local PathTypeG:TGadget = CreatePanel(215, 5, 180, 45, PathGui, PANEL_GROUP, "Path type:")

Global PathTypeRadio1:TGadget = CreateButton("Line", 25, 0, 50, 24, PathTypeG, BUTTON_RADIO)
Global PathTypeRadio2:TGadget = CreateButton("Sine wave", 75, 0, 80, 24, PathTypeG, BUTTON_RADIO)

SetButtonState(PathTypeRadio1, 1)


Local PathSampleGroup:TGadget = CreatePanel(215, 60, 180, 185, PathGui, PANEL_GROUP, "Path sampling parameters:")

Local PathSampleSpacingTxt:TGadget = CreateLabel("Spacing", 5, 5, 70, 15, PathSampleGroup, LABEL_CENTER)
Local PathSampleMultiplierTxt:TGadget = CreateLabel("Divisor", 95, 5, 70, 15, PathSampleGroup, LABEL_CENTER)

Global PathSampleSpacingBox:TGadget = CreateTextField(5, 25, 70, 25, PathSampleGroup)
SetGadgetText(PathSampleSpacingBox, "1")
Global PathSampleMultiplierBox:TGadget = CreateTextField(95, 25, 70, 25, PathSampleGroup)
SetGadgetText(PathSampleMultiplierBox, "2")

Local PathOffsetIncTxt:TGadget = CreateLabel("Offset increment", 5, 55, 120, 15, PathSampleGroup, LABEL_CENTER)
Global PathOffsetIncBox:TGadget = CreateTextField(5, 75, 120, 25, PathSampleGroup)
SetGadgetText(PathOffsetIncBox, "0")



'Preview window GUI
Local PrGroup:TGadget = CreatePanel(10, 520, 500, 50, PrWindow, PANEL_GROUP, "")
SetGadgetLayout(PrGroup, EDGE_CENTERED, EDGE_CENTERED, EDGE_CENTERED, EDGE_ALIGNED)

Local LoadImageBtn:TGadget = CreateButton("UPDATE PREVIEW", 5, 0, 160, 24, PrGroup)

Local ZoomSlider:TGadget = CreateSlider(180, 0, 300, 25, PrGroup, SLIDER_HORIZONTAL | SLIDER_SCROLLBAR)
SetSliderRange(ZoomSlider , 1 , 20) 
SetSliderValue(ZoomSlider , 19) 


'DXF export GUI

Local ExportRangeG:TGadget = CreatePanel(300, 5, 185, 115, ExportGui, PANEL_GROUP, "Dot size range to export (mm):")

'Local ESizeTxt:TGadget = CreateLabel("", 5, 48, 160, 15, ExportRangeG, LABEL_LEFT)
Global ExportActiveBox:TGadget = CreateButton("Active", 5, 5, 100, 24, ExportRangeG, BUTTON_CHECKBOX)

Local EMinSizeTxt:TGadget = CreateLabel("Min.", 5, 35, 80, 15, ExportRangeG, LABEL_CENTER)
Local EMaxSizeTxt:TGadget = CreateLabel("Max.", 90, 35, 80, 15, ExportRangeG, LABEL_CENTER)

Global EMinSizeBox:TGadget = CreateTextField(5, 55, 80, 25, ExportRangeG)
Global EMaxSizeBox:TGadget = CreateTextField(90, 55, 80, 25, ExportRangeG)
SetGadgetText(EMinSizeBox, "0.5")
SetGadgetText(EMaxSizeBox, "10")

Local ExportG:TGadget = CreatePanel(5, 5, 285, 115, ExportGui, PANEL_GROUP, "DXF export:")

Global ExportBox:TGadget = CreateTextField(5, 5, 230, 25, ExportG)
SetGadgetText(ExportBox, "filename.dxf")
Local SelectExportBtn:TGadget = CreateButton("...", 240, 5, 25, 24, ExportG)

Global ExportBorderBox:TGadget = CreateButton("Export border rectangle", 5, 35, 150, 24, ExportG, BUTTON_CHECKBOX)
Local ExportBtn:TGadget = CreateButton("EXPORT DXF", 5, 62, 110, 24, ExportG)


'GCode export GUI

Local ToolGroup:TGadget = CreatePanel(10, 5, 270, 80, GCodeGui, PANEL_GROUP, "Tool and feed:")

Local ToolAngleTxt:TGadget = CreateLabel("V-bit angle", 5, 5, 70, 15, ToolGroup, LABEL_CENTER)
Local FeedTxt:TGadget = CreateLabel("Feedrate", 95, 5, 70, 15, ToolGroup, LABEL_CENTER)

Global ToolAngleBox:TGadget = CreateTextField(5, 25, 70, 25, ToolGroup)
SetGadgetText(ToolAngleBox, "90")
Global FeedBox:TGadget = CreateTextField(95, 25, 70, 25, ToolGroup)
SetGadgetText(FeedBox, "1000")

Local PlungeTxt:TGadget = CreateLabel("Plunge rate", 185, 5, 70, 15, ToolGroup, LABEL_CENTER)
Global PlungeBox:TGadget = CreateTextField(185, 25, 70, 25, ToolGroup)
SetGadgetText(PlungeBox, "400")


Local ZeroPGroup:TGadget = CreatePanel(295, 5, 180, 80, GCodeGui, PANEL_GROUP, "Zero position:")

Global ZPosRadio1:TGadget = CreateButton("", 5, 0, 24, 24, ZeroPGroup, BUTTON_RADIO)
Global ZPosRadio2:TGadget = CreateButton("", 150, 0, 24, 24, ZeroPGroup, BUTTON_RADIO)
Global ZPosRadio3:TGadget = CreateButton("", 5, 40, 24, 24, ZeroPGroup, BUTTON_RADIO)
Global ZPosRadio4:TGadget = CreateButton("", 150, 40, 24, 24, ZeroPGroup, BUTTON_RADIO)
Global ZPosRadio5:TGadget = CreateButton("", 75, 20, 24, 24, ZeroPGroup, BUTTON_RADIO)

SetButtonState(TypeRadio1, 1)


Local SpindleGroup:TGadget = CreatePanel(295, 100, 180, 80, GCodeGui, PANEL_GROUP, "Misc:")

Local SpindleTxt:TGadget = CreateLabel("Spindle rpm", 5, 5, 70, 15, SpindleGroup, LABEL_CENTER)
Local SafeZTxt:TGadget = CreateLabel("Safe Z", 95, 5, 70, 15, SpindleGroup, LABEL_CENTER)

Global SpindleBox:TGadget = CreateTextField(5, 25, 70, 25, SpindleGroup)
SetGadgetText(SpindleBox, "10000")
Global SafeZBox:TGadget = CreateTextField(95, 25, 70, 25, SpindleGroup)
SetGadgetText(SafeZBox, "5")


Local HomeGroup:TGadget = CreatePanel(10, 100, 270, 80, GCodeGui, PANEL_GROUP, "Home position:")

Local HomeXTxt:TGadget = CreateLabel("X", 5, 5, 70, 15, HomeGroup, LABEL_CENTER)
Local HomeYTxt:TGadget = CreateLabel("Y", 95, 5, 70, 15, HomeGroup, LABEL_CENTER)

Global HomeXBox:TGadget = CreateTextField(5, 25, 70, 25, HomeGroup)
SetGadgetText(HomeXBox, "0")
Global HomeYBox:TGadget = CreateTextField(95, 25, 70, 25, HomeGroup)
SetGadgetText(HomeYBox, "0")

Local HomeZTxt:TGadget = CreateLabel("Z", 185, 5, 70, 15, HomeGroup, LABEL_CENTER)
Global HomeZBox:TGadget = CreateTextField(185, 25, 70, 25, HomeGroup)
SetGadgetText(HomeZBox, "10")


Local GExportG:TGadget = CreatePanel(10, 190, 465, 60, GCodeGui, PANEL_GROUP, "GCode export:")

Global GExportBox:TGadget = CreateTextField(5, 5, 230, 25, GExportG)
SetGadgetText(GExportBox, "filename.tap")
Local GSelectExportBtn:TGadget = CreateButton("...", 240, 5, 25, 24, GExportG)

Local GExportBtn:TGadget = CreateButton("EXPORT GCODE", 280, 5, 170, 24, GExportG)


'General global variables and constants

Global Image:TPixmap

Global PrScale:Float = 0
Global Border:Float = 0

Global WorkWidth:Float = 0
Global WorkHeight:Float = 0
Global WorkScale:Float = 0

Global PrZoom:Float = 1

Global FillerColor:Int = 1

Global Feedrate:Int
Global PlungeRate:Int
Global VAngle:Float
Global HomeP:Point = Point.createPoint(0, 0)
Global HomeZ:Float
Global SafeZ:Float
Global SpindleSpeed:Int
Global OptimiseRapids:Int = True

Global ZeroP:Point = Point.createPoint(0, 0)

'dot types
Const CIRCLE:Int = 1
Const SQUARE:Int = 2
Const RSQUARE:Int = 3

'path filler types
Const LINE:Int = 1
Const SINE:Int = 2

Const DebugPixels:Int = False

Filler.Spacing = Float(GadgetText(SpacingBox))

'Preview window client size
Local PrWX:Int
Local PrWY:Int

Global showLegal:Int = True

ShowGadget(MainGui)
HideGadget(DotGui)
HideGadget(PathGui)
HideGadget(ExportGui)
HideGadget(GCodeGui)

Type Point
		
	Field x:float
	Field y:float
		
	Function createPoint:Point(nX:Float, nY:Float)
		
		Local po:Point = New Point
		po.x = nX
		po.y = nY
		Return po
		
	End Function
		
	Function distance:float(p1:Point , p2:Point ) 
		
		Return Sqr((p2.x - p1.x)^2 + (p2.y - p1.y)^2)
		
	End Function
	
	Function makeCopy:Point( orig:Point ) 
		
		Local po:Point = Point.CreatePoint(orig.x, orig.y)
		Return po
		
	End Function
	
	Method isSame:Int(other:Point) 
		
		Return ( x = other.x And y = other.y )
		
	End Method
	
	Method distanceP:float(p2:Point) 
		
		Return Sqr((p2.x - x)^2 + (p2.y - y)^2)
		
	End Method
	
	Method distanceXY:Float(nx:Float, ny:Float)
		
		Return Sqr((x - nx)^2 + (y - ny)^2)
		
	End Method
	
	Method toGlobal:Point(centerP:Point, rot:Float, scale:Float)
		
		Local po:Point = New Point
		
		'Calculating the rotation
		po.x = x * Cos(rot) - y * Sin(rot) 
		po.y = x * Sin(rot) + y * Cos(rot) 
						
		po.x = po.x * scale + centerP.x
		po.y = po.y * scale + centerP.y
				
		Return po
		
	End Method
	
	Method toLocal:Point (centerP:Point, rot:Float, scale:Float)
		
		Local po:Point = New Point

		Local px:float = (x - centerP.x) / scale
		Local py:float = (y - centerP.y) / scale
		
		'Calculating the rotation
		po.x = px * Cos(360.0 - rot) - py * Sin(360 - rot)
		po.y = px * Sin(360.0 - rot) + py * Cos(360 - rot)
				
		Return po
		
	End Method
	
End Type

'Class for single filler dot. Also includes global variables that define the filler grid
Type Filler
	
	Global MinDiameter:Float = 2
	Global MaxDiameter:Float = 10
	
	Global XOffset:Float = 0
	Global YOffset:Float = 0

	Global RowList:TList = CreateList()
	Global FillerType:Int = CIRCLE
	Global Rows:Int = 10
	Global Cols:Int = 10
	Global Spacing:Float
	Global ImgSpacing:Float
	Global Rot:Float
			
	Field WorkX:Float
	Field WorkY:Float
	Field gridX:Int
	Field gridY:Int
	Field Size:Float
	
	Field ImgX:Int
	Field ImgY:Int
	Field PrSize:Float	
		
	Method New()
				
				
	End Method
	
	
	Function Generate(pixmap:TPixmap) 
				
		If Not pixmap Then Return
	
		ClearList(RowList)
		
		Local StartTime:Long = MilliSecs()
		
		Rows = Sqr((WorkWidth + Abs(XOffset) * 1.5) ^ 2 + (WorkHeight + Abs(YOffset) * 1.5) ^ 2) / Spacing
		Cols = Rows
		
		'Image center position in millimeters		
		Local ImgworkCX:Float = (PixmapWidth(pixmap) * .5) * WorkScale
		Local ImgworkCY:Float = (PixmapHeight(pixmap) * .5) * WorkScale
				
		Local xoff:Float = (WorkWidth - Rows * Spacing) * 0.5
		Local yoff:Float = (WorkHeight - Rows * Spacing) * 0.5 + 0.5 * spacing
						
		ImgSpacing = Spacing / WorkScale
		
		Local Fillers:Int
							
		For Local y:Int = 0 To Rows - 1
		
			Local row:TList = CreateList()
		
			For Local x:Int = 0 To  Cols-1
								
				Local wx:Float = (xoff + x * Spacing) - ImgworkCX + XOffset
				Local wy:Float = (yoff + y * spacing) - ImgworkCY + YOffset
				Local px:Float = wx*Cos(rot) - wy*Sin(rot) + ImgworkCX
				Local py:Float = wx*Sin(rot) + wy*Cos(rot) + ImgworkCY
				
				If InRect(border  , border , workwidth - (2 * border) , workheight - (2 * border) , px , py ) Then
																
					Local Fi:Filler = New Filler
										
					Fi.WorkX = px
					Fi.WorkY = py
					Fi.gridX = x
					Fi.gridY = y
					
					Fi.ImgX = Fi.WorkX / WorkScale
					Fi.ImgY = Fi.WorkY / WorkScale 
					
					Fi.CalcSize(pixmap) 
					
					ListAddLast(row, Fi)
					
					Fillers:+1
					
				EndIf
												
			Next
			
			ListAddLast(RowList, row)
			
		Next
		
		Local Gentime:String = (MilliSecs() - starttime) / 1000.0
		Gentime = Left(Gentime, 5)
		
		SetStatusText (PrWindow, Fillers + " dots. " + "Generation time: " + Gentime + "s")
	
		
	End Function
	
	Method CalcSize(pixmap:TPixmap) 
		
		Local pixelvalue:Long
		Local halfdiag:Float = 0.5 * Sqr( 2 * (imgspacing^2) )
		Local Minx:Int = ImgX - halfdiag
		Local Miny:Int = ImgY - halfdiag
		Local Maxx:Int = ImgX + halfdiag
		Local Maxy:Int = ImgY + halfdiag
		
		Local hfimgsp:Float = imgspacing * .5
				
		Local x1:Float = (-HfImgSp) * Cos(rot) + (-HfImgSp) * Sin(rot) 
		x1:+ Imgx
		
		Local x2:Float = (HfImgSp) * Cos(rot) + (-HfImgSp) * Sin(rot) 
		x2:+ Imgx
		
		Local x3:Float = (-HfImgSp) * Cos(rot) + (HfImgSp) * Sin(rot) 
		x3:+ Imgx
		
		Local x4:Float = (HfImgSp) * Cos(rot) + (HfImgSp) * Sin(rot) 
		x4:+ Imgx
		
				
		Local y1:Float = (-HfImgSp) * Sin(rot) - (-HfImgSp) * Cos(rot) 
		y1:+ Imgy
		
		Local y2:Float = (HfImgSp) * Sin(rot) - (-HfImgSp) * Cos(rot) 
		y2:+ Imgy
		
		Local y3:Float = (-HfImgSp) * Sin(rot) - (HfImgSp) * Cos(rot) 
		y3:+ Imgy
		
		Local y4:Float = (HfImgSp) * Sin(rot) - (HfImgSp) * Cos(rot) 
		y4:+ Imgy
		
		Local NumPixels:Int = 0 
		Local rsum:Long = 0
		Local gsum:Long = 0
		Local bsum:Long = 0
		
		Local imgwidth:Int = PixmapWidth(pixmap) 
		Local imgheight:Int = PixmapHeight(pixmap)
				
		For Local y:Int = MinY To MaxY
			For Local x:Int = MinX To MaxX
			
				If InRect(0,0,imgwidth,imgheight,x,y) And (InTriangle(x , y , x1 , y1 , x2 , y2 , x3 , y3) Or InTriangle(x , y , x3 , y3 , x2 , y2 , x4 , y4)) Then
					
					Local x2:Int = x - 1
					If x2 < 0 Then x2 = 0	
					Local y2:Int = y - 1
					If y2<0 Then y2 = 0				
					pixelvalue:Long = ReadPixel(pixmap , x2 , y2) 	
					Local r%, g%, b%
					pixelValue = ($00ffffff & pixelvalue) 'gets rid of the alpha bits making the number make sense
					r = pixelvalue/$10000
					pixelValue = ($00ffff & pixelvalue) 'removes the r value
					g = pixelvalue/$100
					pixelValue = ($00ff & pixelvalue) 'removes the g value leaving only b
					b = pixelvalue		
					
					rsum:+ r
					gsum:+ g
					bsum:+ b
					Numpixels:+1
					
				EndIf		
					
			Next
		Next
				
		Local grayvalue:Float = (Float(gsum) / NumPixels) *.71 + (Float(rsum) / NumPixels) *.21 + (Float(bsum) / NumPixels) *.08
								
		Size = MaxDiameter - MinDiameter
								
		Local A:Float 
		Local D:Float
		
		'TODO make the grayvalue and diameter calculation based on the area of the dot
		Select Filler.FillerType
			Case CIRCLE
				'A = (Pi * (Size * .5) ^ 2) 
				'D = Sqr(A / Pi) * 2
				D = Size
			Case SQUARE
				'A = Size ^ 2
				D = Size
			Case RSQUARE
				'A = Size ^ 2
				D = Size'*Sqr(2)
		End Select
				
		If FillerColor Then
			Size = d * ( Float(grayvalue) / 256.00 )
		Else
			Size = d * ( ( 256-grayvalue ) / 256.00 )
		EndIf
		Size:+ MinDiameter
		If size < 0 Then
			size = 0
			ListRemove(ownerList(), Self)
			'DebugStop
		EndIf

	
	End Method
	
	Method ownerList:TList()
		
		Return TList(RowList.ValueAtIndex(gridY - 1))
	
	End Method
	
	Function countDots:Long()
		
		Local count:Long = 0
		
		Local minsize:Float = Float(GadgetText(EMinSizeBox))
		Local maxsize:Float = Float(GadgetText(EMaxSizeBox))
			
		Local bstate:Int = ButtonState(ExportActiveBox)
		
		For Local Li:TList = EachIn RowList
			
			For Local Fi:Filler = EachIn Li
			
				If ((Not bstate) Or (bstate And (Fi.Size >= minsize And Fi.Size <= maxsize))) Then
					count:+1
				EndIf
		
			Next
			
		next
		
		Return count
		
	End Function
	
	Function ExportDXF:Int(Filename:String) 
		
		If FileType(Filename) = 2 Then Return False
		If FileType(Filename) = 1 Then
			If Not DeleteFile(Filename) Then Return False
		EndIf
		If Not CreateFile(Filename) Then Return False
		Local File:TStream = OpenFile(Filename)
		
		WriteLine File , "  0"
		WriteLine File , "SECTION"
		WriteLine File , "  2"
		WriteLine File , "ENTITIES"
	
		'export the border rectangle
		If (ButtonState(ExportBorderBox)) Then
			
			writeWorkRect(File)
		
		End If
	
		Local minsize:Float = Float(GadgetText(EMinSizeBox))
		Local maxsize:Float = Float(GadgetText(EMaxSizeBox))
			
		Local bstate:Int = ButtonState(ExportActiveBox)
				
		For Local Li:TList = EachIn RowList
						
			For Local Fi:Filler = EachIn Li
							
				
				If ((Not bstate) Or (bstate And (Fi.Size >= minsize And Fi.Size <= maxsize))) Then
					
					If (FillerType = CIRCLE) Then
						
						writeCircle(File, Fi.WorkX, -Fi.WorkY, Fi.Size)
									
					Else 'export squares as polylines
						
						WriteLine File, "  0"
						WriteLine File, "POLYLINE"
	  					WriteLine File, "  10"
						WriteLine File, "  0.0"
						WriteLine File, "  20"
						WriteLine File, "  0.0"
						WriteLine File, "  30"
						WriteLine File, "  0.0"
						WriteLine File, "  70"
						WriteLine File, "  1"
						WriteLine File, "  0"
	 					
						Local points:Float[]
						
						If (Filler.FillerType = SQUARE)
							
							Local r:Float = fi.Size / 2
						
							points = [Fi.WorkX - r, -Fi.WorkY - r, Fi.WorkX + r, -Fi.WorkY - r, Fi.WorkX + r, -Fi.WorkY + r, Fi.WorkX - r, -Fi.WorkY + r]
																		
						Else If (Filler.FillerType = RSQUARE)
						
							Local r:Float = fi.Size / Sqr(2)
						
							points = [Fi.WorkX, -Fi.WorkY - r, Fi.WorkX + r, -Fi.WorkY, Fi.WorkX, -Fi.WorkY + r, Fi.WorkX - r, -Fi.WorkY]
										
						EndIf
						
						For Local i:Int = 0 To 6 Step 2
													
							WriteLine File, "VERTEX"
							WriteLine File, "  10"
							WriteLine File, points[i]
							WriteLine File, "  20"
							WriteLine File, points[i + 1]
							WriteLine File, "  0"
							
						Next
						
						WriteLine File, "SEQEND"
															
					EndIf
	
				EndIf
			Next
								
		Next
		
		WriteLine File, "  0"
		WriteLine File, "ENDSEC"
		WriteLine File, "  0"
		WriteLine File, "EOF"
		
		CloseFile(File) 
		
		SetStatusText (MainWindow, "Exported to " + Filename)
		
		If (ButtonState(AutoSaveBox))
		
			Local filename2:String = StripExt(Filename) + "_settings.txt"
			
			If (SaveSettings(filename2)) Then
				
				SetStatusText (MainWindow, "Exported to " + Filename + " Settings saved to " + StripDir(filename2))
				
			End If
		
		EndIf
		
		Return True
	
	End Function
	
	
	Function ExportGCode:Int(Filename:String)
		
		If FileType(Filename) = 2 Then Return False
		If FileType(Filename) = 1 Then
			If Not DeleteFile(Filename) Then Return False
		EndIf
		If Not CreateFile(Filename) Then Return False
		Local File:TStream = OpenFile(Filename)
		
		writeGCodeIntro(File)
		
		Local minsize:Float = Float(GadgetText(EMinSizeBox))
		Local maxsize:Float = Float(GadgetText(EMaxSizeBox))
			
		Local bstate:Int = ButtonState(ExportActiveBox)
		
		Local tanAngle:Float = Tan(VAngle / 2)
		
		Local i:Int = 1
		
		RowList.Reverse()
		
		For Local Li:TList = EachIn RowList
		
			If i Mod 2 Then
				Li.Reverse()
			End If
						
			For Local Fi:Filler = EachIn Li
				
				'the size limits from dxf export tab also affect the gcode generation
				If ((Not bstate) Or (bstate And (Fi.Size >= minsize And Fi.Size <= maxsize))) Then
				
					Local ZDepth:Float = -(Fi.Size * 0.5) / tanAngle
				
					WriteLine File, "G0 X" + (ZeroP.x + Fi.WorkX) + " Y" + (ZeroP.y - Fi.WorkY) 'y coordinate must be inverted
					WriteLine File, "G0 Z" + SafeZ
					
					WriteLine File, "G1 Z" + ZDepth + " F" + PlungeRate
					WriteLine File, "G0 Z" + SafeZ
					
				EndIf
				
			Next
			
			If i Mod 2 Then
				Li.Reverse()
			End If
			
			i:+1
			
		Next
		
		RowList.Reverse()
			
		writeGCodeOutro(File)
		
		CloseFile(File)
				
		SetStatusText (MainWindow, "Exported to " + Filename)
		
		If (ButtonState(AutoSaveBox))
		
			Local filename2:String = StripExt(Filename) + "_settings.txt"
			
			If (SaveSettings(filename2)) Then
				
				SetStatusText (MainWindow, "Exported to " + Filename + " Settings saved to " + StripDir(filename2))
				
			End If
		
		EndIf
		
		Return True
		
	End Function
	
	Function DrawFillers(scale:Float, XOff:Int, YOff:Int)
		
		For Local Li:TList = EachIn RowList
		
			For Local Fi:Filler = EachIn Li
					
				Local d:Float = Fi.Size * scale 
				
				Local x:Float
				Local y:Float
				
				Select Filler.FillerType
					Case CIRCLE
						
						x = Xoff + (Fi.WorkX) * scale - .5*d
						y = YOff + (Fi.WorkY) * scale - .5*d
						DrawOval(x , y , d , d) 
						
					Case SQUARE
						
						x = Xoff + (Fi.WorkX) * scale - .5*d
						y = YOff + (Fi.WorkY) * scale - .5*d
						DrawRect(x , y , d , d) 
										
					Case RSQUARE
						
						SetRotation(45)
						x = XOff + Fi.WorkX * scale
						y = YOff + Fi.WorkY * scale - 1.41421356 * 0.5 * d 'sqrt(2)
						DrawRect(x, y, d, d)
						SetRotation(0)
						
				End Select
								
			Next
		Next
			
	End Function
	
	
End Type

Type PathFiller
	
	Global FillerList:TList = CreateList()

	Global FillerType:Int = SINE
	
	Global spacing:Float = 100
	Global sampleSpacing:Float = 2
	Global sampleMultiplier:Int = 2
	Global Rot:Float = 30
	Global wavelength:Float = 50
	Global amplitude:Float = 25
	Global offsetIncrement:Float = 0
	Global xoffset:Float = 0
	Global yoffset:Float = 0
			
	Global minDia:Float = 1
	Global maxDia:Float = 10
	
	Global arrayRows:Int
	Global arrayCols:Int
	
	Const maxRows:Int = 100
	Const maxCols:Int = 100
		
	Global sampleArray:TList[maxCols, maxRows]
			
	Field startP:Point
	Field endP:Point
	Field length:Float
	Field offset:Float
		
	Field PointList:TList = CreateList()
	
	Method New()
	
			
	End Method
	
	Function GenerateFiller(source:TPixmap)
		
		Local startTime:Long = MilliSecs()
		Local sampleCount:Long = 0
		
		'ugly fix for a nasty, but rare, problem
		If (WorkWidth = WorkHeight And Rot Mod 45 = 0 And Rot <> 0) Then
			Rot:+0.001
		End If
		
		ClearList(FillerList)
						
		Local workStartX:Float = WorkWidth / 2 + Xoffset
		Local workStartY:Float = WorkHeight / 2 + Yoffset
		
		'Work area rectangle corner points
		Local areap1:Point = Point.createPoint(0 + border, 0 + border)
		Local areap2:Point = Point.createPoint(workwidth - border, 0 + border)
		Local areap3:Point = Point.createPoint(workwidth - border, workheight - border)
		Local areap4:Point = Point.createPoint(border, workheight - border)
		
		'Create the filler objects with start and end points
		
		For Local n:Int = -1 To 1 Step 2
					
			Local lineSPoint:Point = Point.createPoint(workStartX, workStartY)
			Local fillerOffset:Float = 0
			
			'don't make the first line twice.
			If (n = 1) Then
				lineSPoint.x:+n * Spacing * Cos(Rot + 90)
				lineSPoint.y:+n * Spacing * Sin(Rot + 90)
				fillerOffset:+offsetIncrement
			End If
			
			'DebugStop
							
			Repeat
				
				Local pfi:PathFiller = New PathFiller
				pfi.offset = fillerOffset
				
				Local intp1:Point = intPoint(areap1, areap2, lineSPoint, Rot)
				Local intp2:Point = intPoint(areap2, areap3, lineSPoint, Rot)
				Local intp3:Point = intPoint(areap3, areap4, lineSPoint, Rot)
				Local intp4:Point = intPoint(areap4, areap1, lineSPoint, Rot)
				
				If (intp1) Then
					pfi.startP = intp1
				End If
				
				If (intp2) Then
					If (pfi.startP) Then
						pfi.endP = intp2
					Else
						pfi.startP = intp2
					End If
				End If
				
				If (intp3) Then
					If (pfi.startP) Then
						pfi.endP = intp3
					Else
						pfi.startP = intp3
					End If
				End If
				
				If (intp4) Then
					pfi.endP = intp4
				End If
				
				'The line does not cross the work area
				If Not (intp1 Or intp2 Or intp3 Or intp4) Then
					Exit
				EndIf
				
				If Not (pfi.startP And pfi.endP) Then
					Print "line/segment error!"
					DebugStop
				End If
				
				pfi.length = pfi.startP.distanceP(pfi.endP)
				
				Local dx:Float = (pfi.endP.x - pfi.startP.x)
				Local dy:Float = (pfi.endP.y - pfi.startP.y)
			
				Local tanDir:Float = stATan2(dx, dy)
				
				If (stAtan2(dx, dy) > 180)
					
					Local temp:Point = pfi.endP
					pfi.endP = pfi.startP
					pfi.startP = temp
				
				EndIf
				
				If FillerType = SINE Then
					pfi.offset:+NormalDistance(0, 0, Cos(tanDir + 90), Sin(tanDir + 90), pfi.startP.x, pfi.startP.y)
				EndIf
																
				ListAddLast(FillerList, pfi)
				
				'update the line startpoint location
				lineSPoint.x:+n * Spacing * Cos(Rot + 90)
				lineSPoint.y:+n * Spacing * Sin(Rot + 90)
				fillerOffset:+offsetIncrement
							
				
			Forever
				
		Next
		
		Print "line generation time: " + (MilliSecs() - startTime)
		
		Local sampleGentime:Long = MilliSecs()
		
		'generate the sampling points
		For Local pfi:PathFiller = EachIn FillerList
			
			Local numPoints:Int = Ceil(pfi.length / sampleSpacing)
			Local dx:Float = (pfi.endP.x - pfi.startP.x)
			Local dy:Float = (pfi.endP.y - pfi.startP.y)
			
			Local tanDir:Float = stATan2(dx, dy)
						
			'Spacing is the distance along the line, not in x-axis
			dx = sampleSpacing * Cos(tanDir)
			dy = sampleSpacing * Sin(tanDir)
									
			For Local i:Int = 0 To numPoints
				
				Local pp:PathPoint = New PathPoint
									
				If (i Mod sampleMultiplier = 0 Or i = numPoints) Then
					pp.imageSample = True
				Else
					pp.imageSample = False
				EndIf
							
				If (FillerType = LINE)
					
					Local posX:Float = pfi.startP.x + i * dx
					Local posY:Float = pfi.startP.y + i * dy
										
					pp.Position = Point.createPoint(posX, posY)
					pp.tangentDir = tanDir
			
				ElseIf (FillerType = SINE)
									
					Local posX:Float = i * samplespacing
					
					Local wl:Float = (2 * Pi / wavelength)
					Local offset:Float = wl * (pfi.offset)
					
					'sin takes values in degrees, not radians					
					Local sinInput:Float = (posx * wl + offset) * (180 / Pi)
					Local posY:Float = (amplitude / 2) * Sin(sinInput)
										
					pp.Position = Point.createPoint(posX, -posY)
					
					'derivate of the sin-function gives the tangent slope
					pp.tangentDir = tanDir - ATan((amplitude / 2) * Cos(sinInput) * wl)
					
					'rotate the point around origin and move to final position
					Local positX:Float = pp.Position.x * Cos(tanDir) - pp.Position.y * Sin(tanDir)
					Local positY:Float = pp.Position.x * Sin(tanDir) + pp.Position.y * Cos(tanDir)
									
					pp.Position.x = positX + pfi.startP.x
					pp.Position.y = positY + pfi.startP.y
											
							
				EndIf
				
								
				'If the sampling point is inside the work area
				If (InRect(areap1.x, areap1.y, areap2.x - areap1.x, areap3.y - areap1.y, pp.Position.x, pp.Position.y))
					
					If Not (FillerType = LINE And pp.imageSample = False) Then
						ListAddLast(pfi.PointList, pp)
						sampleCount:+1
					End If
															
				ElseIf FillerType = LINE And pp.imageSample
										
					pp.Position = Point.makeCopy(pfi.endP)
					ListAddLast(pfi.PointList, pp)
					sampleCount:+1
																		
				EndIf
							
			Next
			
			'first and last sample points must be imagesamples
			If Not pfi.PointList.isEmpty() Then
				PathPoint(pfi.PointList.First()).imageSample = True
				PathPoint(pfi.PointList.Last()).imageSample = True
			EndIf
						
		Next
		
		Print "sample generation time: " + (MilliSecs() - sampleGentime)
		
		Local sampleArraytime:Long = MilliSecs()
		
		'put the sample points into the array
		updateSampleArray()
		
		Print "sample array update time: " + (MilliSecs() - sampleArraytime)
		
		Local samplesizetime:Long = MilliSecs()
		
		'calculate the sample point diameters from pixmap
		calcSampleSizes(source)
		
		Print "sample sizing time: " + (MilliSecs() - samplesizetime)
		
		Local Gentime:String = (MilliSecs() - starttime) / 1000.0
		Gentime = Left(Gentime, 5)
		
		SetStatusText (PrWindow, FillerList.count() + " paths, " + sampleCount + " sample points. " + "Generation time: " + Gentime + "s")
		
	End Function
		
	Function calcSampleSizes(source:TPixmap)
		
		Local imgScale:Float = WorkWidth / source.width
				
		Local cellWidth:Float = WorkWidth / arraycols
		Local cellHeight:Float = WorkHeight / arrayrows
		
		Local starttime:Long = MilliSecs()
		
		'loop through every pixel in the image and add the values to nearest sample point	
		For Local y:Int = 0 To source.Height - 1
			
			Local pixelY:Float = y * imgScale
			Local arrayY:Int = Floor(pixelY / (cellHeight))
			
			For Local x:Int = 0 To source.width - 1
								
				Local pixelX:Float = x * imgScale
				Local arrayX:Int = Floor(pixelX / (cellwidth))
												
				Local mindist:Float = 1000000
				
				Local closestPP:PathPoint = Null
				
				'find the closest pathpoint within the array cell
				'With large source images this loop can run for tens of millions cycles, so it has to be simple.
				For Local pp:PathPoint = EachIn sampleArray[arrayX, arrayY]
										
					If (Not pp.imageSample)
						Continue
					End If
										
					'as the actual distance value is not important, we can compare the distance^2 values ( removes sqr )
					'this works because sqr is strictly increasing when x > 0
					Local px:Float = pp.Position.x - pixelX
					Local py:Float = pp.Position.y - pixelY
					Local dist:Float = px * px + py * py
					
					
					If (dist < mindist) Then
						
						closestPP = pp
						mindist = dist
					
					End If
									
				Next
				
				If (closestPP) Then
										
					'extract the r,g,b values from pixmap
					Local pixelvalue:Long = ReadPixel(source, x, y)
					Local r%, g%, b%
					pixelValue = ($00ffffff & pixelvalue) 'gets rid of the alpha bits making the number make sense
					r = pixelvalue/$10000
					pixelValue = ($00ffff & pixelvalue) 'removes the r value
					g = pixelvalue/$100
					pixelValue = ($00ff & pixelvalue) 'removes the g value leaving only b
					b = pixelvalue		
					
					closestPP.rsum:+r
					closestPP.gsum:+g
					closestPP.bsum:+b
					
					closestPP.NumPixels:+1
					
					If DebugPixels Then
						ListAddLast(closestPP.pixelList, Point.createPoint(x, y))
					EndIf
					
				Else
				
					'Print "pathpoint not found!"
					'Print "px: " + pixelX + " py: " + pixelY
					'Print "arrx: " + arrayX + " arry: " + arrayY
					'Print "count: " + sampleArray[arrayX, arrayY].count()
					'DebugStop
				
				End If
								
							
			Next
		
		Next
		
		Print "pixel looping time: " + (MilliSecs() - starttime)
		
		Local sizeCalcTime:Long = MilliSecs()
		
		'loop through the sample points and calculate the diameter and p1,p2
		For Local pfi:PathFiller = EachIn FillerList
			
			Local lastimgSample:PathPoint = Null
			Local extraPoints:TList = CreateList()
							
			For Local pp:PathPoint = EachIn pfi.PointList
											
				Local grayvalue:Float
				Local Size:Float = MaxDia - MinDia
				
				Local lastpoint:Int = (pp = PathPoint(pfi.PointList.Last()))
				
				If (pp.imageSample And pp.NumPixels > 1) Or lastpoint Then
								
					grayvalue = (pp.gsum / Float(pp.NumPixels)) *.71 + (pp.rsum / Float(pp.NumPixels)) *.21 + (pp.bsum / Float(pp.NumPixels)) *.08
																											
					If FillerColor Then
						Size = Size * (Float(grayvalue) / 256.00)
					Else
						Size = Size * ((256 - grayvalue) / 256.00)
					EndIf
					
					If (pp.imageSample And lastimgSample) Or lastpoint
					
						Local sizeVar:Float
					
						If (pp.NumPixels > 1) Then
							sizeVar = ((Size + minDia) - (lastimgSample.Size)) / (extraPoints.count() + 1)
						Else
							sizeVar = 0
						EndIf
							
						Local i:Int = 1
																
						For Local pp2:PathPoint = EachIn extraPoints
														
							pp2.Size = (lastimgSample.Size) + i * sizeVar
							pp2.calcPoints()
														
							i:+1
							
						Next
																
					End If
					
				Else
				
					pp.imageSample = False
					ListAddLast(extraPoints, pp)
				
				EndIf
								
				If Size <= 0 Then
					Size = 0
					'DebugStop
				EndIf
								
				Size:+minDia
				
				If (pp.imageSample) Then
					
					pp.Size = Size
					pp.calcPoints()
					lastimgSample = pp
					ClearList(extraPoints)
					
				End If
														
			Next
				
		Next
		
		For Local pfi:PathFiller = EachIn FillerList
									
			For Local pp:PathPoint = EachIn pfi.PointList
							
				If pp.Size <= 0 Then
					
					If (pp = PathPoint(pfi.PointList.First()))
						
						Local pp2:PathPoint
												
						For Local i:Int = 1 To pfi.PointList.count()
						
							pp2 = PathPoint(pfi.PointList.ValueAtIndex(i))
							If pp2.imageSample Then
								Exit
							End If
													
						Next
						
						pp.Size = pp2.Size
						pp.calcPoints()
						
					Else
						ListRemove(pfi.PointList, pp)
					EndIf
									
				EndIf
			
			Next
			
		Next
		
		Print "size calculation time: " + (MilliSecs() - sizeCalcTime)
	
	End Function
		
	Function updateSampleArray()
		
		'clearing the array
		For Local y:Int = 0 To maxRows - 1
		
			For Local x:Int = 0 To maxCols - 1
				
				If (sampleArray[x, y])
					sampleArray[x, y].Clear()
				Else
					sampleArray[x, y] = CreateList()
				End If
								
			Next
		
		Next
		
		arrayCols = WorkWidth / (spacing * Cos(Rot) * 1.42)
		arrayRows = WorkHeight / (spacing * Sin(Rot) * 1.42)
				
		If arrayCols > maxCols Then arrayCols = maxCols
		If arrayRows > maxRows Then arrayRows = maxRows
		
		If arrayCols < 1 Then arrayCols = 1
		If arrayRows < 1 Then arrayRows = 1
		
		If (Image.width / arrayCols) < 10 Then
			arrayCols = Image.width / 10
		End If
		
		If (Image.Height / arrayRows) < 10 Then
			arrayRows = Image.Height / 10
		End If
		
		If (arrayCols * 5 < arrayRows) Then
			arrayCols = arrayRows
		Else If (arrayRows * 5 < arrayCols) Then
			arrayRows = arrayCols
		End If
		
		Print "rows: " + arrayRows + " cols: " + arrayCols
												
		Local cellWidth:Float = (WorkWidth) / (arraycols)
		Local cellHeight:Float = (WorkHeight) / (arrayrows)
			
		For Local pfi:PathFiller = EachIn FillerList
			
			For Local pp:PathPoint = EachIn pfi.PointList
				
				If (Not pp.imageSample) Then
					Continue
				End If
			
				'one PathPoint can be in 2 array cells at the same time, this fixes problems at the edges of array cells
			
				Local arrayX:Int = Floor(pp.Position.x / cellwidth)
				Local arrayY:Int = Floor(pp.Position.y / cellHeight)
										
				Local arrayX1:Int = Floor((pp.Position.x - samplespacing * 2) / cellwidth)
				Local arrayY1:Int = Floor((pp.Position.y - samplespacing * 2) / cellHeight)
								
				Local arrayX2:Int = Floor((pp.Position.x + samplespacing * 2) / cellwidth)
				Local arrayY2:Int = Floor((pp.Position.y + samplespacing * 2) / cellHeight)
				
				If (arrayX >= arrayCols) Then arrayX = arrayCols - 1
				If (arrayY >= arrayRows) Then arrayY = arrayRows - 1
				If (arrayX1 >= arrayCols) Then arrayX1 = arrayCols - 1
				If (arrayY1 >= arrayRows) Then arrayY1 = arrayRows - 1
				If (arrayX2 >= arrayCols) Then arrayX2 = arrayCols - 1
				If (arrayY2 >= arrayRows) Then arrayY2 = arrayRows - 1
				
				If (arrayX < 0) Then arrayX = 0
				If (arrayY < 0) Then arrayY = 0
				If (arrayX1 < 0) Then arrayX1 = 0
				If (arrayY1 < 0) Then arrayY1 = 0
				If (arrayX2 < 0) Then arrayX2 = 0
				If (arrayY2 < 0) Then arrayY2 = 0
				
				ListAddLast(sampleArray[arrayX, arrayY], pp)
				
				If (arrayX1 <> arrayX) Then
					ListAddLast(sampleArray[arrayX1, arrayY], pp)
				End If
				
				If (arrayY1 <> arrayY) Then
					ListAddLast(sampleArray[arrayX, arrayY1], pp)
				End If
				
				If (arrayX2 <> arrayX) Then
					ListAddLast(sampleArray[arrayX2, arrayY], pp)
				End If
				
				If (arrayY2 <> arrayY) Then
					ListAddLast(sampleArray[arrayX, arrayY2], pp)
				End If
				
				'Print "posx  : " + pp.Position.x + " posy  : " + pp.Position.y
				'Print "arrayx: " + arrayX + " arrayY: " + arrayY
				
				'If (arrayX < 0) Then arrayX = 0
				'If (arrayY < 0) Then arrayY = 0
								
											
			Next
		
		Next
	
	
	End Function
	
	'intersection point with line segment and line defined by point and direction		
	Function intPoint:Point(p1:Point, p2:point, lp:Point, ldir:Float)
		
		Local segDir:Double = ATan2(p2.y - p1.y, p2.x - p1.x)
		
		'segment and line are parallel
		If (segDir = ldir Or (((segDir + 180) Mod 360) = ldir)) Then
			
			Return Null
			
		EndIf
			
		Local iPoint:Point = IntersectPoint(p1.x, p1.y, p2.x, p2.y, lp.x, lp.y, lp.x + 1 * Cos(ldir) , lp.y + 1 * Sin(ldir))
		
		Local segLength:Double = Point.Distance(p1, p2)
					
		'The intersection point for lines is not on this segment		
		If (iPoint.distanceP(p1) > segLength Or iPoint.distanceP(p2) > segLength)
			
			Return Null
			
		EndIf
				
		'Print "Intersection point: X: " + iPoint.x + " Y: " + iPoint.y 
		
		Return iPoint
		
	End Function
	
	Function ExportDXF:Int(Filename:String)
		
		If FileType(Filename) = 2 Then Return False
		If FileType(Filename) = 1 Then
			If Not DeleteFile(Filename) Then Return False
		EndIf
		If Not CreateFile(Filename) Then Return False
		Local File:TStream = OpenFile(Filename)
		
		WriteLine File , "  0"
		WriteLine File , "SECTION"
		WriteLine File , "  2"
		WriteLine File , "ENTITIES"
		
		
		'export the border rectangle
		If (ButtonState(ExportBorderBox)) Then
			
			writeWorkRect(File)
		
		End If
		
		For Local pfi:PathFiller = EachIn FillerList
														
			WriteLine File, "  0"
			WriteLine File, "POLYLINE"
			WriteLine File, "  10"
			WriteLine File, "  0.0"
			WriteLine File, "  20"
			WriteLine File, "  0.0"
			WriteLine File, "  30"
			WriteLine File, "  0.0"
			WriteLine File, "  70"
			WriteLine File, "  1"
			WriteLine File, "  0"
						
			
			For Local pp:PathPoint = EachIn pfi.PointList
														
				WriteLine File, "VERTEX"
				WriteLine File, "  10"
				WriteLine File, pp.p1.x
				WriteLine File, "  20"
				WriteLine File, -pp.p1.y
				WriteLine File, "  0"
				
			
			Next
			
			pfi.PointList.Reverse()
			
			For Local pp:PathPoint = EachIn pfi.PointList
														
				WriteLine File, "VERTEX"
				WriteLine File, "  10"
				WriteLine File, pp.p2.x
				WriteLine File, "  20"
				WriteLine File, -pp.p2.y
				WriteLine File, "  0"
				
			
			Next					
			
			WriteLine File, "SEQEND"
			
			pfi.PointList.Reverse()
				
		Next
		
		WriteLine File, "  0"
		WriteLine File, "ENDSEC"
		WriteLine File, "  0"
		WriteLine File, "EOF"
		
		CloseFile(File) 
		
		SetStatusText (MainWindow, "Exported to " + Filename)
		
		If (ButtonState(AutoSaveBox))
		
			Local filename2:String = StripExt(Filename) + "_settings.txt"
			
			If (SaveSettings(filename2)) Then
				
				SetStatusText (MainWindow, "Exported to " + Filename + " Settings saved to " + StripDir(filename2))
				
			End If
		
		EndIf
		
		Return True
	
	End Function
	
	
	Function ExportGCode:Int(Filename:String)
		
		If FileType(Filename) = 2 Then Return False
		If FileType(Filename) = 1 Then
			If Not DeleteFile(Filename) Then Return False
		EndIf
		If Not CreateFile(Filename) Then Return False
		Local File:TStream = OpenFile(Filename)
		
		writeGCodeIntro(File)
		
		Local tanAngle:Float = Tan(VAngle / 2)
		
		Local i:Int = 0
						
		For Local pfi:PathFiller = EachIn FillerList
			
			'this will optimise the rapid moves between lines
			If (i Mod 2 = 1) And OptimiseRapids Then
				pfi.PointList.Reverse()
			End If
		
			For Local pp:PathPoint = EachIn pfi.PointList
				
				Local ZDepth:Float = -(pp.Size * 0.5) / tanAngle
			
				If (pp = PathPoint(pfi.PointList.First())) Then
					
					WriteLine File, "G0 X" + (ZeroP.x + pp.Position.X) + " Y" + (ZeroP.y - pp.Position.Y) 'y coordinate must be inverted	
					WriteLine File, "G1 Z" + ZDepth + " F" + PlungeRate
					WriteLine File, "F" + Feedrate
						
				EndIf
								
				WriteLine File, "X" + (ZeroP.x + pp.Position.X) + " Y" + (ZeroP.y - pp.Position.Y) + " Z" + ZDepth
			
			Next
			
			If (i Mod 2 = 1) And OptimiseRapids Then
				pfi.PointList.Reverse()
			End If
			
			WriteLine File, "G0 Z" + SafeZ
			i:+1
			
		Next
		
		writeGCodeOutro(File)
		
		CloseFile(File)
				
		
		SetStatusText (MainWindow, "Exported to " + Filename)
		
		If (ButtonState(AutoSaveBox))
		
			Local filename2:String = StripExt(Filename) + "_settings.txt"
			
			If (SaveSettings(filename2)) Then
				
				SetStatusText (MainWindow, "Exported to " + Filename + " Settings saved to " + StripDir(filename2))
				
			End If
		
		EndIf
		
		Return True
		
	End Function
	
	
	
	
	Function drawPaths(scale:Float, XOff:Int, YOff:Int)
		
		For Local pfi:PathFiller = EachIn FillerList
			
			pfi.drawPath(scale, XOff, YOff)
		
		Next
	
	End Function
	
	Method drawPath(scale:Float, XOff:Int, YOff:Int)
		
		Local sDrawX:Float = XOff + startP.x * scale
		Local sDrawY:Float = YOff + startP.y * scale
		Local eDrawX:Float = XOff + endP.x * scale
		Local eDrawY:Float = YOff + endP.y * scale
				
		Local lastP:PathPoint = Null 'the pathpoint before
		
		Local r:Int
		Local g:Int
		Local b:Int
		
		GetColor(r, g, b)
		
		Local scale2:Float
		
		'used for pixeldebug drawing
		If (Image.width > Image.Height) Then
			scale2:Float = (MainCanvas.ClientWidth() - 10) / Float(PixmapWidth(Image))
		Else
			scale2:Float = (MainCanvas.ClientHeight() - 10) / Float(PixmapHeight(Image))
		EndIf
		
		
					
		For Local pp:PathPoint = EachIn PointList
			
			If (lastP)
				
				Local p1x:Float = XOff + lastP.p1.x * scale
				Local p1y:Float = YOff + lastP.p1.y * scale
				
				Local p2x:Float = XOff + pp.p1.x * scale
				Local p2y:Float = YOff + pp.p1.y * scale
				
				Local p3x:Float = XOff + pp.p2.x * scale
				Local p3y:Float = YOff + pp.p2.y * scale
				
				Local p4x:Float = XOff + lastP.p2.x * scale
				Local p4y:Float = YOff + lastP.p2.y * scale
							
				Local polyArr:Float[] = [p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y]
											
				DrawPoly(polyArr)
											
			EndIf
			
			'SetColor(255, 0, 0)
			
			'Local DrawX:Float = XOff + pp.Position.x * scale
			'Local DrawY:Float = YOff + pp.Position.y * scale
						
			'DrawOval(DrawX - pp.Size / 2, DrawY - pp.Size / 2, pp.Size, pp.Size)
			
			
			If (DebugPixels) Then
								
				SetColor(Rand(0, 255), Rand(0, 255), Rand(0, 255))
												
				For Local po:Point = EachIn pp.pixelList
					
					Plot(XOff + po.x * scale2, YOff + po.y * scale2)
				
				Next
				
				SetColor(r, g, b)
				
			End If
			
			
			lastP = pp
			
		Next
		
		'SetColor(0, 255, 0)
		'DrawLine(sDrawX, sDrawY, eDrawX, eDrawY)
		'DrawOval(sDrawX - 2, sDrawY - 2, 4, 4)
		'SetColor(255, 255, 255)
		
			
	End Method
	
End Type

Type PathPoint
	
	Field imageSample:Int = False
	Field pixelList:TList = CreateList()
	Field Position:Point
	Field p1:Point
	Field P2:Point
	Field tangentDir:Float
	Field Size:Float
	
	Field NumPixels:Int = 0
	Field rsum:Long = 0
	Field gsum:Long = 0
	Field bsum:Long = 0
	
	
	Method New()
		
		If DebugPixels Then
			
			pixelList:TList = CreateList()
		
		End If
	
	End Method
	
	Method calcPoints()
		
		Local r:Float = Size / 2
												
		p1 = Point.CreatePoint(r * Cos(tangentDir + 90) + Position.x, r * Sin(tangentDir + 90) + Position.y)
		P2 = Point.CreatePoint(r * Cos(tangentDir - 90) + Position.x, r * Sin(tangentDir - 90) + Position.y)
		
'		If p1.x < 0 Then
'			DebugStop
'		End If
				
	End Method
	
End Type


Function UpdatePreview(Target:TGadget)
	
	Local PrWidth:Int = Target.ClientWidth() - 10
	Local PrHeight:Int = Target.ClientHeight() - 10
	
	Local ImgWidth:Int = PixmapWidth(image)
	Local ImgHeight:Int = PixmapHeight(Image) 
		
	If imgwidth > imgheight Then
		
		PrScale = prWidth / ImgWidth
		PrHeight = PrWidth * (Imgheight / Float(ImgWidth))
				
	Else
		
		PrScale = PrHeight / imgheight
		PrWidth = PrHeight * (Float(ImgWidth) / Imgheight)
			
	EndIf
	
		
	Local scale:Float = (PrWidth / WorkWidth)
	Local XOff:Int = (Target.ClientWidth() - PrWidth) *.5
	Local YOff:Int = (Target.ClientHeight() - PrHeight) *.5
	
	SetGraphics CanvasGraphics(Target)
			
	If FillerColor Then
		
		SetColor(255 , 255 , 255) 
		DrawRect(0, 0, Target.ClientWidth(), Target.ClientHeight())
		SetColor(0 , 0 , 0) 
		DrawRect(XOff, YOff, PrWidth, PrHeight)
		SetColor(255 , 255 , 255) 
		
	Else
		
		SetColor(0 , 0 , 0) 
		DrawRect(0, 0, Target.ClientWidth(), Target.ClientHeight())
		SetColor(255 , 255 , 255) 
		DrawRect(XOff, YOff, PrWidth, PrHeight)
		SetColor(0,0,0)
		
	EndIf
		
	If (ButtonState(ActiveRadio1)) Then
		
		Filler.DrawFillers(scale, XOff, YOff)
		
	Else
	
		PathFiller.drawPaths(scale, XOff, YOff)
		
	End If
	
	If (PrZoom <> 1) Then
		
		Local PrImg:TImage = CreateImage(Target.ClientWidth(), Target.ClientHeight(), 1, MIPMAPPEDIMAGE | DYNAMICIMAGE)
		
		'grab the full-size preview to image
		GrabImage(PrImg, 0, 0)
		
		If FillerColor Then
			SetColor(255, 255, 255)
		Else
			SetColor(0, 0, 0)
		EndIf
		
		'clear the canvas
		DrawRect(0, 0, Target.ClientWidth(), Target.ClientHeight())
		
		SetColor(255, 255, 255)
		
		'calculate the image position on screen
				
		Local XOff2:Int = (Target.ClientWidth() - PrImg.width * PrZoom) *.5
		Local YOff2:Int = (Target.ClientHeight() - PrImg.Height * PrZoom) *.5
		'DebugStop
		'draw the image with mipmapping for smoother look!
		SetScale(PrZoom, PrZoom)
		DrawImage(PrImg, XOff2, YOff2)
		
		SetScale(1, 1)
		
	End If
			
		
End Function

'Load the source image into pixmap and calculates the work size variables
Function ImageLoad:Int()
	
	If Not LoadPixmap(TextFieldText(LoadImageBox) ) 
		Return False
	EndIf
		
	Image = LoadPixmap(TextFieldText(LoadImageBox) ) 
	
	Local ImgWidth:Int = PixmapWidth(image)
	Local ImgHeight:Int = PixmapHeight(Image) 
			
	If Int(GadgetText(widthbox) ) > 0 Then
				
		WorkWidth = Float(GadgetText(widthbox) )
		WorkScale = workwidth / imgwidth 
		WorkHeight = WorkWidth * ( Float(imgheight) / imgwidth )
		SetGadgetText(HeightBox , WorkHeight) 
		
				
	ElseIf Int(GadgetText(heightbox) ) > 0
	
		WorkHeight = Float(GadgetText(HeightBox))
		WorkScale = workHeight / imgHeight 
		WorkWidth = WorkHeight / ( Float(imgheight) / imgwidth )
		SetGadgetText(WidthBox , WorkWidth) 
		
		
	Else
		
		WorkWidth = (ImgWidth * (Filler.Spacing)) + 2 * Border
		WorkScale = workwidth / imgwidth 
		WorkHeight = WorkWidth * ( Float(imgheight) / imgwidth )
		SetGadgetText(HeightBox,WorkHeight)
		SetGadgetText(WidthBox , WorkWidth) 
						
	EndIf
		
		'Filler.Spacing = ( (WorkWidth - 2 * Border) / ImgWidth )
	
	SetStatusText (MainWindow, "Image loaded. " + ImgWidth * ImgHeight + " pixels.")
	
	Return True
	
End Function

Function SaveSettings:Int(Filename:String) 
	
	filename = Trim(Filename)

	If FileType(Filename) = 2 Then Return False
	If FileType(Filename) = 1 Then
		If Not DeleteFile(Filename) Then Return False
	EndIf
	If Not CreateFile(Filename) Then Return False
	Local File:TStream = OpenFile(Filename)
	
	Local ActiveFiller:Int
	
	If (ButtonState(ActiveRadio1)) Then
		ActiveFiller = 1
	Else
		ActiveFiller = 2
	End If
	
	WriteLine File, ";GENERAL SETTINGS"
	WriteLine File, "inputfile " + GadgetText(LoadImageBox)
	WriteLine File, "width " + WorkWidth
	WriteLine File, "height " + WorkHeight
	WriteLine File, "border " + Border
	WriteLine File, "colorsw " + FillerColor
	WriteLine File, "activefiller " + ActiveFiller
	WriteLine File, "autosave " + ButtonState(AutoSaveBox)
	WriteLine File, "showlegalnotice " + showLegal
	WriteLine File, ""
	
	WriteLine File, ";DOT GRID SETTINGS"
	WriteLine File, "spacing " + Filler.Spacing
	WriteLine File, "rotation " + Filler.rot
	WriteLine File, "mindia " + Filler.MinDiameter
	WriteLine File, "maxdia " + Filler.MaxDiameter
	WriteLine File, "xoffset " + Filler.XOffset
	WriteLine File, "yoffset " + Filler.YOffset
	WriteLine File, "ftype " + Filler.FillerType
	WriteLine File, ""
	
	WriteLine File, ";PATH SETTINGS"
	WriteLine File, "pathspacing " + PathFiller.Spacing
	WriteLine File, "pathrotation " + PathFiller.rot
	WriteLine File, "pathmindia " + PathFiller.MinDia
	WriteLine File, "pathmaxdia " + PathFiller.MaxDia
	WriteLine File, "pathwavelength " + PathFiller.wavelength
	WriteLine File, "pathamplitude " + PathFiller.amplitude
	WriteLine File, "pathxoffset " + PathFiller.XOffset
	WriteLine File, "pathyoffset " + PathFiller.YOffset
	WriteLine File, "pathftype " + PathFiller.FillerType
	WriteLine File, "pathoffsetincrement " + PathFiller.offsetIncrement
	WriteLine File, "pathsamplespacing " + PathFiller.sampleSpacing
	WriteLine File, "pathsamplemultiplier " + PathFiller.sampleMultiplier
	WriteLine File, ""
		
	WriteLine File, ";DXF EXPORT SETTINGS"
	WriteLine File, "exportfile " + Trim(GadgetText(ExportBox))
	WriteLine File, "exportborderactive " + ButtonState(ExportBorderBox)
	WriteLine File, "exportrangeactive " + ButtonState(ExportActiveBox)
	WriteLine File, "exportminsize " + Trim(GadgetText(EMinSizeBox))
	WriteLine File, "exportmaxsize " + Trim(GadgetText(EMaxSizeBox))
	WriteLine File, ""
		
	WriteLine File, ";GCODE EXPORT SETTINGS"
	WriteLine File, "gexportfile " + Trim(GadgetText(GExportBox))
	WriteLine File, "homex " + Trim(GadgetText(HomeXBox))
	WriteLine File, "homey " + Trim(GadgetText(HomeYBox))
	WriteLine File, "homez " + Trim(GadgetText(HomeZBox))
	WriteLine File, "zerox " + ZeroP.x
	WriteLine File, "zeroy " + ZeroP.y
	WriteLine File, "safez " + Trim(GadgetText(SafeZBox))
	WriteLine File, "spindlespeed " + Trim(GadgetText(SpindleBox))
	WriteLine File, "vbitangle " + Trim(GadgetText(ToolAngleBox))
	WriteLine File, "feedrate " + Trim(GadgetText(FeedBox))
	WriteLine File, "plungerate " + Trim(GadgetText(PlungeBox))
	WriteLine File, "optimiserapids " + OptimiseRapids
	WriteLine File, ""
				
	CloseFile File
	Return True
	
End Function

Function LoadSettings:Int(Filename:String) 
	
	If FileType(Filename) = 2 Then Return False
	Local File:TStream = OpenFile(Filename)
	If Not File Then Return False
	
	Local Line_const:Int = LINE
		
	Repeat
		Local Line:String = ReadLine(File)
		If Not (Left(Line,1) = ";") And Len(Line) > 1 Then
			Local Cmd:String = Lower(GetToken(Line, 0, " "))
			If Cmd = "inputfile" Then
				SetGadgetText(LoadImageBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "showlegalnotice" Then
				showLegal = Int(GetToken(LINE, 1, " "))
			ElseIf Cmd = "width" Then
				SetGadgetText(WidthBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "height" Then
				SetGadgetText(HeightBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "border" Then
				SetGadgetText(Borderbox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "spacing" Then
				SetGadgetText(SpacingBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "rotation" Then
				SetGadgetText(RotationBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "mindia" Then
				SetGadgetText(MinDiaBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "maxdia" Then
				SetGadgetText(MaxDiaBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "xoffset" Then
				SetGadgetText(XOffBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "yoffset" Then
				SetGadgetText(YOffBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "pathspacing" Then
				SetGadgetText(PathSpacingBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathrotation" Then
				SetGadgetText(PathRotationBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathmindia" Then
				SetGadgetText(PathMinDiaBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathmaxdia" Then
				SetGadgetText(PathMaxDiaBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathwavelength" Then
				SetGadgetText(PathwavelengthBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathamplitude" Then
				SetGadgetText(PathAmplitudeBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathxoffset" Then
				SetGadgetText(PathXOffBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "pathyoffset" Then
				SetGadgetText(PathYOffBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "pathoffsetincrement" Then
				SetGadgetText(PathOffsetIncBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathsamplespacing" Then
				SetGadgetText(PathSampleSpacingBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "pathsamplemultiplier" Then
				SetGadgetText(PathSamplemultiplierBox, GetToken(LINE, 1, " "))
'			ElseIf Cmd = "settingsfile" Then
'				SetGadgetText(SettingsBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "autosave" Then
				SetButtonState(AutoSaveBox, Int(GetToken(Line, 1, " ")))
			ElseIf Cmd = "exportsize" Then
				SetGadgetText(EMinSizeBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "exportminsize" Then
				SetGadgetText(EMinSizeBox, GetToken(Line, 1, " "))
			ElseIf Cmd = "exportmaxsize" Then
				SetGadgetText(EMaxSizeBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "exportrangeactive" Then
				SetButtonState(ExportActiveBox, Int(GetToken(LINE, 1, " ")))
			ElseIf Cmd = "exportborderactive" Then
				SetButtonState(ExportBorderBox, Int(GetToken(LINE, 1, " ")))
			ElseIf Cmd = "gexportfile" Then
				SetGadgetText(GExportBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "homex" Then
				SetGadgetText(HomeXBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "homey" Then
				SetGadgetText(HomeYBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "homez" Then
				SetGadgetText(HomeZBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "zerox" Then
				ZeroP.x = Float(GetToken(LINE, 1, " "))
			ElseIf Cmd = "zeroy" Then
				ZeroP.y = Float(GetToken(LINE, 1, " "))
			ElseIf Cmd = "safez" Then
				SetGadgetText(SafeZBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "spindlespeed" Then
				SetGadgetText(SpindleBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "vbitangle" Then
				SetGadgetText(ToolAngleBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "feedrate" Then
				SetGadgetText(FeedBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "plungerate" Then
				SetGadgetText(PlungeBox, GetToken(LINE, 1, " "))
			ElseIf Cmd = "optimiserapids" Then
				OptimiseRapids = Int(GetToken(LINE, 1, " "))
			ElseIf Cmd = "colorsw" Then
				If Int(GetToken(Line, 1, " ")) = 1 Then
					SetButtonState(ColorRadio1 , True) 
					SetButtonState(ColorRadio2 , False) 
					FillerColor = 1
				Else
					SetButtonState(ColorRadio2 , True) 
					SetButtonState(ColorRadio1 , False)
					FillerColor = 0
				EndIf
			ElseIf Cmd = "activefiller" Then
				If Int(GetToken(LINE, 1, " ")) = 1 Then
					SetButtonState(ActiveRadio1, True)
					SetButtonState(ActiveRadio2, False)
					
				Else
					SetButtonState(ActiveRadio2, True)
					SetButtonState(ActiveRadio1, False)
				EndIf
			ElseIf Cmd = "ftype" Then
				Select Int(GetToken(Line, 1, " "))
					Case CIRCLE
						SetButtonState(TypeRadio1 , True) 
						SetButtonState(TypeRadio2 , False) 
						SetButtonState(TypeRadio3 , False) 
					Case SQUARE
						SetButtonState(TypeRadio2 , True) 
						SetButtonState(TypeRadio1 , False) 
						SetButtonState(TypeRadio3 , False) 
					Case RSQUARE
						SetButtonState(TypeRadio3 , True) 
						SetButtonState(TypeRadio1 , False) 
						SetButtonState(TypeRadio2 , False)
				End Select
				Filler.FillerType = Int(GetToken(Line, 1, " "))
			ElseIf Cmd = "pathftype" Then
				Select Int(GetToken(Line, 1, " "))
					Case Line_const
						SetButtonState(PathTypeRadio1, True)
						SetButtonState(PathTypeRadio2, False)
					Case SINE
						SetButtonState(PathTypeRadio1, False)
						SetButtonState(PathTypeRadio2, True)
				End Select
				PathFiller.FillerType = Int(GetToken(Line, 1, " "))
					
			ElseIf Cmd = "exportfile" Then
				SetGadgetText(ExportBox, GetToken(Line, 1, " "))

			EndIf				
		EndIf
	Until Eof(File)
		
	CloseFile File
	Return True
	
End Function


LoadSettings("HTSettings.txt")

If (showLegal) Then
	ShowGadget(LegalWindow)
End If

'If we have valid image path, generate and show the filler
If Imageload() Then
		
	UpdateVariables()
	
	If (ButtonState(ActiveRadio1)) Then
		Filler.Generate(Image)
	Else
		PathFiller.GenerateFiller(Image)
	End If
		
	UpdatePreview(MainCanvas)
	
EndIf


'Main loop

Repeat

	'Set to true when the filler needs to be regenerated
	Local regenFiller:Int = False
	Local regenPathFiller:Int = False
	
	'Set to true when the preview needs to be redrawn
	Local updatepr:Int = False

				
	WaitEvent()
	
	' Handling of all GUI events
	Select EventID()
		Case EVENT_WINDOWCLOSE
			Select EventSource()
				Case MainWindow
					UpdateVariables()
					SaveSettings("HTSettings.txt") 
					End
				Case PrWindow
					UpdateVariables()
					SaveSettings("HTSettings.txt")
					End	
			End Select
		
		Case EVENT_WINDOWSIZE
			Select EventSource()
				
			'The resize events don't seem to get generated sometimes. I'm checking the size change manually elsewhere
				Case PrWindow
					'FreeGadget MainCanvas
					'MainCanvas = CreateCanvas(10, 10, ClientWidth(PrWindow) - 20, ClientHeight(PrWindow) - 50 - 20, PrWindow)
					'UpdatePreview(MainCanvas)
									
			End Select
			
		Case EVENT_GADGETACTION

			Select EventSource()
				
				Case MainTabber
				
					Select EventData()
						Case 0
													
							ShowGadget(MainGui)
							HideGadget(DotGui)
							HideGadget(ExportGui)
							HideGadget(PathGUI)
							HideGadget(GCodeGui)
							
						Case 1
							
							HideGadget(MainGui)
							ShowGadget(DotGui)
							HideGadget(ExportGui)
							HideGadget(PathGUI)
							HideGadget(GCodeGui)
							
						Case 2
							
							HideGadget(MainGui)
							HideGadget(DotGui)
							ShowGadget(PathGUI)
							HideGadget(ExportGui)		
							HideGadget(GCodeGui)
							
						Case 3
							
							HideGadget(MainGui)
							HideGadget(DotGui)
							HideGadget(PathGUI)
							ShowGadget(ExportGui)
							HideGadget(GCodeGui)
							
						Case 4
							
							HideGadget(MainGui)
							HideGadget(DotGui)
							HideGadget(PathGUI)
							HideGadget(ExportGui)
							ShowGadget(GCodeGui)
													
					End Select
				
				Case SelectImageBtn
				
					Local dir:String = AppDir + "/"
				
					If (ExtractDir(GadgetText(LoadImageBox)) <> "")
					
						dir = ExtractDir(GadgetText(LoadImageBox)) + "\"
					
					EndIf
										
					Local newdir:String = RequestFile("Select source image", "jpeg,png,jpg,gif,bmp", False, dir)
					
					If (newdir) Then
						
						SetGadgetText(LoadImageBox, newdir)
					
					End If
				
				Case SelectSettingsBtn
					
					Local dir:String = AppDir + "/"
				
					If (ExtractDir(GadgetText(SettingsBox)) <> "")
					
						dir = ExtractDir(GadgetText(SettingsBox)) + "\"
					
					EndIf
										
					Local newdir:String = RequestFile("Select settings file:", "txt", False, dir)
					
					If (newdir) Then
						
						SetGadgetText(SettingsBox, newdir)
					
					End If
					
				Case SelectExportBtn
					
					Local dir:String = AppDir + "/"
				
					If (ExtractDir(GadgetText(ExportBox)) <> "")
					
						dir = ExtractDir(GadgetText(ExportBox)) + "\"
					
					EndIf
										
					Local newdir:String = RequestFile("Save as dxf:", "dxf", True, dir)
					
					If (newdir) Then
						
						SetGadgetText(ExportBox, newdir)
						If ButtonState(ActiveRadio1) Then
							Filler.ExportDXF(newdir)
						Else
							PathFiller.ExportDXF(newdir)
						End If
												
					End If
				
				Case GSelectExportBtn
					
					Local dir:String = AppDir + "/"
					
					If (ExtractDir(GadgetText(GExportBox)) <> "")
						dir = ExtractDir(GadgetText(GExportBox)) + "\"
					EndIf
										
					Local newdir:String = RequestFile("Save as gcode:", "tap", True, dir)
										
					If (newdir) Then
						
						UpdateVariables()
						SetGadgetText(GExportBox, newdir)
						If ButtonState(ActiveRadio1) Then
							Filler.ExportGCode(newdir)
						Else
							PathFiller.ExportGCode(newdir)
						End If
												
					End If	
				
				Case CloseButton
					
					showLegal = Not ButtonState(noticeButton)
					HideGadget(LegalWindow)
						
				Case LoadSettingsBtn
				
					LoadSettings(GadgetText(SettingsBox))
					UpdateVariables()
					ImageLoad()
					regenFiller = True
					regenPathFiller = True
					updatepr = True
					
				Case SaveSettingsBtn
				
					SaveSettings(GadgetText(SettingsBox))	
					
				Case LoadImageBtn
					
					UpdateVariables()
					ImageLoad() 
					regenFiller = True
					regenPathFiller = True
					updatepr = True
									
				Case FitDiaBtn
					
					If Filler.Spacing > 0 Then
						
						UpdateVariables()
						Filler.MinDiameter = Float(GadgetText(MinDiaBox))
						Filler.MaxDiameter = Filler.Spacing - Filler.MinDiameter
						
						SetGadgetText(MaxDiaBox, Filler.MaxDiameter)
						regenFiller = True 
						updatepr = True
					EndIf
				
				Case ExportBtn
					
					UpdateVariables()
				
					If (ButtonState(ActiveRadio1)) Then
						Filler.ExportDXF(GadgetText(ExportBox))
					Else
						PathFiller.ExportDXF(GadgetText(ExportBox))
					End If
				
				Case GExportBtn
					 
					UpdateVariables()
					If (ButtonState(ActiveRadio1)) Then
						Filler.ExportGCode(GadgetText(GExportBox))
					Else
						PathFiller.ExportGCode(GadgetText(GExportBox))
					End If
										
				Case ZoomSlider
					PrZoom = 0.05 + (SliderValue(ZoomSlider)/20.00)
					updatepr = True
										
				Case ColorRadio1					
					FillerColor = 1
					regenFiller = True
					regenPathFiller = True
					updatepr = True
				Case ColorRadio2
					FillerColor = 0
					regenFiller = True
					regenPathFiller = True
					updatepr = True
				
				Case ActiveRadio1
					regenFiller = True
					updatepr = True
				Case ActiveRadio2
					regenPathFiller = True
					updatepr = True
				
				Case TypeRadio1
					Filler.FillerType = CIRCLE
					regenFiller = True 
					updatepr = True
				Case TypeRadio2
					Filler.FillerType = SQUARE
					regenFiller = True 
					updatepr = True
				Case TypeRadio3
					Filler.FillerType = RSQUARE
					regenFiller = True 
					updatepr = True
				
				Case PathTypeRadio1
					PathFiller.FillerType = Line
					regenPathFiller = True
					updatepr = True
				Case PathTypeRadio2
					PathFiller.FillerType = SINE
					regenPathFiller = True
					updatepr = True
					
				Case ZPosRadio1
					ZeroP.x = 0
					ZeroP.y = 0
				Case ZPosRadio2
					ZeroP.x = -WorkWidth
					ZeroP.y = 0
				Case ZPosRadio3
					ZeroP.x = 0
					ZeroP.y = WorkHeight
				Case ZPosRadio4
					ZeroP.x = -WorkWidth
					ZeroP.y = WorkHeight
				Case ZPosRadio5
					ZeroP.x = -WorkWidth / 2
					ZeroP.y = WorkHeight / 2
										
			End Select
		
	End Select
	
	If (ClientWidth(PrWindow) <> PrWX Or ClientHeight(PrWindow) <> PrWY)
	
		PrWX = ClientWidth(PrWindow)
		PrWY = ClientHeight(PrWindow)
	
		FreeGadget MainCanvas 'cannot be resized, so we have to remove it and make a new one
		MainCanvas = CreateCanvas(10, 10, ClientWidth(PrWindow) - 20, ClientHeight(PrWindow) - 50 - 20, PrWindow)
				
		If (Image And Not updatepr) Then
			UpdatePreview(MainCanvas)
		EndIf
		
	EndIf
	
	If (regenFiller And ButtonState(ActiveRadio1) And Image) Then
		
		Filler.Generate(Image)
			
	EndIf
	
	If (regenPathFiller And ButtonState(ActiveRadio2) And Image) Then
		
		PathFiller.GenerateFiller(Image)
		
	End If
	
	If (updatepr And Image) Then
		UpdatePreview(MainCanvas)
	End If
	
	
	Flip
		
Until AppTerminate()

UpdateVariables()
SaveSettings("HTSettings.txt")
end

'Updates the global variables from UI textboxes
Function UpdateVariables()
	
	Border = Float(GadgetText(Borderbox))

	Filler.MinDiameter = Float(GadgetText(MinDiaBox))
	Filler.MaxDiameter = Float(GadgetText(MaxDiaBox))
	Filler.Spacing = Float(GadgetText(SpacingBox))
	Filler.rot = Float(GadgetText(RotationBox))
		
	Filler.XOffset = Float(GadgetText(XOffBox))
	Filler.YOffset = Float(GadgetText(YOffBox))
		
	PathFiller.MinDia = Float(GadgetText(PathMinDiaBox))
	PathFiller.MaxDia = Float(GadgetText(PathMaxDiaBox))
	PathFiller.Spacing = Float(GadgetText(PathSpacingBox))
	PathFiller.rot = Float(GadgetText(PathRotationBox))
		
	PathFiller.XOffset = Float(GadgetText(PathXOffBox))
	PathFiller.YOffset = Float(GadgetText(PathYOffBox))
	PathFiller.offsetIncrement = Float(GadgetText(PathOffsetIncBox))
	
	PathFiller.wavelength = Float(GadgetText(PathwavelengthBox))
	PathFiller.amplitude = Float(GadgetText(PathAmplitudeBox))
	
	PathFiller.sampleSpacing = Float(GadgetText(PathSampleSpacingBox))
	PathFiller.sampleMultiplier = Int(GadgetText(PathSampleMultiplierBox))
	
	If PathFiller.sampleMultiplier < 1 Then
		PathFiller.sampleMultiplier = 1
		SetGadgetText(PathSampleMultiplierBox, "1")
	End If
	
	SafeZ = Float(GadgetText(SafeZBox))
	
	HomeP.x = Float(GadgetText(HomeXBox))
	HomeP.y = Float(GadgetText(HomeYBox))
	HomeZ = Float(GadgetText(HomeZBox))
	
	If (HomeZ < SafeZ) Then
		
		HomeZ = SafeZ
		SetGadgetText(HomeZBox, SafeZ)
	
	End If
		
	SpindleSpeed = Float(GadgetText(SpindleBox))
	VAngle = Float(GadgetText(ToolAngleBox))
	Feedrate = Float(GadgetText(FeedBox))
	PlungeRate = Float(GadgetText(PlungeBox))
		
	
End Function

'export the border rectangle
Function writeWorkRect(File:TStream)
	
	WriteLine File, "  0"
	WriteLine File, "POLYLINE"
	WriteLine File, "  10"
	WriteLine File, "  0.0"
	WriteLine File, "  20"
	WriteLine File, "  0.0"
	WriteLine File, "  30"
	WriteLine File, "  0.0"
	WriteLine File, "  70"
	WriteLine File, "  1"
	WriteLine File, "  0"
		
	Local points:Float[]
						
	points = [0.0, 0.0, WorkWidth, 0.0, WorkWidth, -WorkHeight, 0.0, -WorkHeight]
				
	For Local i:Int = 0 To 6 Step 2
								
		WriteLine File, "VERTEX"
		WriteLine File, "  10"
		WriteLine File, points[i]
		WriteLine File, "  20"
		WriteLine File, points[i + 1]
		WriteLine File, "  0"
		
	Next
	
	WriteLine File, "SEQEND"
	


End Function

Function writeCircle(File:TStream, x:Float, y:Float, diam:Float)
	
	WriteLine File, "  0"
	WriteLine File, "CIRCLE"
	WriteLine File, "  8"
	WriteLine File, "Default"
			
	WriteLine File, " 10"
	WriteLine File, x
					
	WriteLine File, " 20"
	WriteLine File, y
	
	WriteLine File , " 30"
	WriteLine File , "0.0"
	
	WriteLine File , " 40"
	WriteLine File, diam / 2

End Function

Function writeGCodeIntro(File:TStream)

	WriteLine File, "; This file was automatically generated by DXF Halftone " + VERSION + " (c) Metalfusion 2011"
	WriteLine File, "; Creation date: " + CurrentDate() + " " + CurrentTime()
	WriteLine File, "; Source image filename: " + StripDir(GadgetText(LoadImageBox))
	WriteLine File, "; To be cut with " + Int(VAngle) + " degree V-bit."
	
	
	If (ButtonState(ActiveRadio1)) Then
		WriteLine File, "; The pattern contains " + Filler.countDots() + " dots."
	End If
	
	WriteLine File, "; Use at your own risk."
	
	WriteLine File, ";"
	
	WriteLine File, "G17"
	WriteLine File, "G40"
	WriteLine File, "G80"
	WriteLine File, "G90"
	WriteLine File, "G97 " + "S" + SpindleSpeed
	WriteLine File, ";"
	
	WriteLine File, "M3"
	
	WriteLine File, ";"
	WriteLine File, "G0 Z" + SafeZ
	WriteLine File, "G0 X" + HomeP.x + " Y" + HomeP.y
	WriteLine File, "G0 Z" + HomeZ
	WriteLine File, ";"
	
			
End Function

Function writeGCodeOutro(File:TStream)
	
	WriteLine File, "G0 Z" + SafeZ
	WriteLine File, ";"
	
	WriteLine File, "M05"
	WriteLine File, "G0 X" + HomeP.x + " Y" + HomeP.y
	WriteLine File, "G0 Z" + HomeZ
	WriteLine File, "M02"
	
End Function


'Checks if a point is inside a triangle
Function InTriangle:Int(x0:Int,y0:Int,x1:Int,y1:Int,x2:Int,y2:Int,x3:Int,y3:Int)
	Local b0:Float =  (x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1)
	Local b1:Float = ((x2 - x0) * (y3 - y0) - (x3 - x0) * (y2 - y0)) / b0 
	If b1 <= 0 Then Return False
	
	Local b2:Float = ((x3 - x0) * (y1 - y0) - (x1 - x0) * (y3 - y0)) / b0
	If b2 <= 0 Then Return False

	Local b3:Float = ((x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0)) / b0 
	If b3 <= 0 Then Return False
	
	Return True
End Function

'Checks if a point is inside a rectangle
Function InRect:Int(X:Float, Y:Float, W:Float, H:Float, TX:Float, TY:Float)
	If ((TX >= X) And (TX <= X+W)) And ((TY >= Y) And (TY <= Y+H)) Then Return True
	Return False
End Function

Function IntersectPoint:Point(x1:float, y1:float, x2:float, y2:float, x3:float, y3:float, x4:float, y4:float)
	'Function returns the X,Y position of the two intersecting lines.
	'The lines are infinite, is line1 goes through x1,y1,x2,y2 And line2 goes through x3,y3,x4,y4.
	'For line segments you must check If the lines truly intersect with the Function Intersect% before you use this.
	
	Local dx1:Float = x2 - x1
	Local dx2:Float = x4 - x3
	Local dx3:Float = x1 - x3
	
	Local dy1:Float = y2 - y1
	Local dy2:Float = y1 - y3
	Local dy3:Float = y4 - y3
	
	Local intersectX:Float
	Local intersectY:Float
			
	Local R:Double = dx1 * dy3 - dy1 * dx2
	
	If R <> 0 Then
		R  = (dy2 * (x4 - x3) - dx3 * dy3) / R
		IntersectX = x1 + R * dx1
		IntersectY = y1 + R * dy1
	Else
		If (((x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1)) = 0) Then
			IntersectX = x3 
			IntersectY = y3
		Else
			IntersectX = x4
			IntersectY = y4
		EndIf
	EndIf
	
	Return Point.CreatePoint(intersectX , intersectY) 
		
End Function

Function GetToken:String(TokenString:String,Index:Int,Lim:String=" ")
	If Len(TokenString:String)<2 Then Return TokenString:String
	If Index=0 Then
		If Instr(TokenString:String,Lim:String) = 0 Then
			Return TokenString:String
		Else
			Return Left:String(TokenString:String,Instr(TokenString:String,Lim:String)-1)
		EndIf
	EndIf
	Local SCount:Int = CharCount(TokenString:String,Lim:String)
	If SCount = 0 Then Return TokenString
	If Index>CharCount(TokenString:String,Lim:String) Then Return Left:String(TokenString:String,Instr(TokenString:String,Lim:String)-1)
	Local FoundIndex:Int=0,Char:Int=0,GetLen:Int=0
	While FoundIndex<Index And Char<Len(TokenString:String)
		If Mid:String(TokenString:String,Char+1,1) = Lim:String Then FoundIndex=FoundIndex+1
		Char=Char+1
	Wend
	While Char+GetLen<Len(TokenString:String)
		GetLen=GetLen+1
		If Mid:String(TokenString:String,Char+GetLen+1,1)=Lim:String Then Exit
	Wend
	Return Mid:String(TokenString:String,Char+1,GetLen)
End Function

Function CharCount:Int(SearchString:String,Char:String)
	Local SCounter:Int = 0
	If SearchString:String = "" Then Return 0
	For Local Index:Int=1 To Len(SearchString:String)
		If Mid:String(SearchString:String,Index,1) = Char:String Then SCounter = SCounter + 1
	Next
	Return SCounter
End Function

Function stAtan2:Double(a:Double, b:Double)
	
	Local norm:Double = ATan2( a , b ) 
	norm = - norm - 90 + 180
	norm = norm Mod 360
	
	If ( norm < 0 ) Then
		norm = 360 + norm
	EndIf
	
	Return norm
	
End Function

Function NormalDistance:Float (lx1:Float, ly1:Float, lx2:Float, ly2:Float, x:Float, y:Float)
	' This function calculates the lenght of the normal from point to line.
	' The line is infinite, so the points lx1,ly1 and lx2,ly2 only determine that the line passes through them.
	' So the 'line' does not start from lx1,ly1 and end to lx2,ly2.
	
	Local dx:Float = lx2 - lx1
	Local dy:Float = ly2 - ly1
	
	Local d:Float = Sqr(dx * dx + dy * dy)
			
	Return Abs((dx * (ly1 - y) - (lx1 - x) * dy) / d)
		
End Function